## ros-lunar-pcl-ros 1.5.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(pcl_ros)

## Find system dependencies
find_package(cmake_modules REQUIRED)
find_package(Boost REQUIRED COMPONENTS system filesystem thread)
find_package(Eigen3 REQUIRED)
find_package(PCL REQUIRED COMPONENTS core features filters io segmentation surface)

if(NOT "${PCL_LIBRARIES}" STREQUAL "")
  # For debian: https://github.com/ros-perception/perception_pcl/issues/139
  list(REMOVE_ITEM PCL_LIBRARIES
    "vtkGUISupportQt"
    "vtkGUISupportQtOpenGL"
    "vtkGUISupportQtSQL"
    "vtkGUISupportQtWebkit"
    "vtkViewsQt"
    "vtkRenderingQt")
endif()

## Find catkin packages
find_package(catkin REQUIRED COMPONENTS
  dynamic_reconfigure
  genmsg
  nodelet
  nodelet_topic_tools
  pcl_conversions
  pcl_msgs
  pluginlib
  rosbag
  rosconsole
  roscpp
  roslib
  sensor_msgs
  std_msgs
  tf
  tf2_eigen
)

## Add include directories
include_directories(include
  ${Boost_INCLUDE_DIRS}
  ${catkin_INCLUDE_DIRS}
  ${Eigen3_INCLUDE_DIRS}
  ${PCL_INCLUDE_DIRS}
)

## Generate dynamic_reconfigure
generate_dynamic_reconfigure_options(
  cfg/EuclideanClusterExtraction.cfg
  cfg/ExtractIndices.cfg
  cfg/ExtractPolygonalPrismData.cfg
  cfg/Feature.cfg
  cfg/Filter.cfg
  cfg/MLS.cfg
  cfg/SACSegmentation.cfg
  cfg/SACSegmentationFromNormals.cfg
  cfg/SegmentDifferences.cfg
  cfg/StatisticalOutlierRemoval.cfg
  cfg/RadiusOutlierRemoval.cfg
  cfg/VoxelGrid.cfg
  cfg/CropBox.cfg
)

## Declare the catkin package
catkin_package(
  INCLUDE_DIRS include
  LIBRARIES
    pcl_ros_filters
    pcl_ros_io
    pcl_ros_tf
  CATKIN_DEPENDS
    dynamic_reconfigure
    message_filters
    nodelet
    nodelet_topic_tools
    pcl_conversions
    pcl_msgs
    rosbag
    roscpp
    sensor_msgs
    std_msgs
    tf
  DEPENDS
    Boost
    Eigen3
    PCL
)

## Declare the pcl_ros_tf library
add_library(pcl_ros_tf src/transforms.cpp)
target_link_libraries(pcl_ros_tf ${Boost_LIBRARIES} ${catkin_LIBRARIES} ${Eigen3_LIBRARIES} ${PCL_LIBRARIES})
add_dependencies(pcl_ros_tf pcl_ros_generate_messages_cpp ${catkin_EXPORTED_TARGETS})

## Nodelets

## Declare the pcl_ros_io library
add_library(pcl_ros_io
  src/pcl_ros/io/bag_io.cpp
  src/pcl_ros/io/concatenate_data.cpp
  src/pcl_ros/io/concatenate_fields.cpp
  src/pcl_ros/io/io.cpp
  src/pcl_ros/io/pcd_io.cpp
)
target_link_libraries(pcl_ros_io pcl_ros_tf ${Boost_LIBRARIES} ${catkin_LIBRARIES} ${Eigen3_LIBRARIES} ${PCL_LIBRARIES})
class_loader_hide_library_symbols(pcl_ros_io)

## Declare the pcl_ros_features library
add_library(pcl_ros_features
  src/pcl_ros/features/feature.cpp
  # Compilation is much faster if we include all the following CPP files in feature.cpp
  src/pcl_ros/features/boundary.cpp
  src/pcl_ros/features/fpfh.cpp
  src/pcl_ros/features/fpfh_omp.cpp
  src/pcl_ros/features/shot.cpp
  src/pcl_ros/features/shot_omp.cpp
  src/pcl_ros/features/moment_invariants.cpp
  src/pcl_ros/features/normal_3d.cpp
  src/pcl_ros/features/normal_3d_omp.cpp
  src/pcl_ros/features/pfh.cpp
  src/pcl_ros/features/principal_curvatures.cpp
  src/pcl_ros/features/vfh.cpp
)
target_link_libraries (pcl_ros_features ${Boost_LIBRARIES} ${catkin_LIBRARIES} ${Eigen3_LIBRARIES} ${PCL_LIBRARIES})
add_dependencies(pcl_ros_features ${PROJECT_NAME}_gencfg)
class_loader_hide_library_symbols(pcl_ros_features)


## Declare the pcl_ros_filters library
add_library(pcl_ros_filters
  src/pcl_ros/filters/extract_indices.cpp
  src/pcl_ros/filters/filter.cpp
  src/pcl_ros/filters/passthrough.cpp
  src/pcl_ros/filters/project_inliers.cpp
  src/pcl_ros/filters/radius_outlier_removal.cpp
  src/pcl_ros/filters/statistical_outlier_removal.cpp
  src/pcl_ros/filters/voxel_grid.cpp
  src/pcl_ros/filters/crop_box.cpp
)
target_link_libraries(pcl_ros_filters pcl_ros_tf ${Boost_LIBRARIES} ${catkin_LIBRARIES} ${Eigen3_LIBRARIES} ${PCL_LIBRARIES})
add_dependencies(pcl_ros_filters ${PROJECT_NAME}_gencfg)
class_loader_hide_library_symbols(pcl_ros_filters)

## Declare the pcl_ros_segmentation library
add_library (pcl_ros_segmentation
  src/pcl_ros/segmentation/extract_clusters.cpp
  src/pcl_ros/segmentation/extract_polygonal_prism_data.cpp
  src/pcl_ros/segmentation/sac_segmentation.cpp
  src/pcl_ros/segmentation/segment_differences.cpp
  src/pcl_ros/segmentation/segmentation.cpp
)
target_link_libraries(pcl_ros_segmentation pcl_ros_tf ${Boost_LIBRARIES} ${catkin_LIBRARIES} ${Eigen3_LIBRARIES} ${PCL_LIBRARIES})
add_dependencies(pcl_ros_segmentation ${PROJECT_NAME}_gencfg)
class_loader_hide_library_symbols(pcl_ros_segmentation)

## Declare the pcl_ros_surface library
add_library (pcl_ros_surface
  src/pcl_ros/surface/surface.cpp
  # Compilation is much faster if we include all the following CPP files in surface.cpp
  src/pcl_ros/surface/convex_hull.cpp
  src/pcl_ros/surface/moving_least_squares.cpp
)
target_link_libraries(pcl_ros_surface ${Boost_LIBRARIES} ${catkin_LIBRARIES} ${Eigen3_LIBRARIES} ${PCL_LIBRARIES})
add_dependencies(pcl_ros_surface ${PROJECT_NAME}_gencfg)
class_loader_hide_library_symbols(pcl_ros_surface)

## Tools

add_executable(pcd_to_pointcloud tools/pcd_to_pointcloud.cpp)
target_link_libraries(pcd_to_pointcloud ${Boost_LIBRARIES} ${catkin_LIBRARIES} ${Eigen3_LIBRARIES} ${PCL_LIBRARIES})

add_executable(pointcloud_to_pcd tools/pointcloud_to_pcd.cpp)
target_link_libraries(pointcloud_to_pcd ${Boost_LIBRARIES} ${catkin_LIBRARIES} ${Eigen3_LIBRARY_DIRS} ${PCL_LIBRARIES})

add_executable(bag_to_pcd tools/bag_to_pcd.cpp)
target_link_libraries(bag_to_pcd pcl_ros_tf ${Boost_LIBRARIES} ${catkin_LIBRARIES} ${Eigen3_LIBRARY_DIRS} ${PCL_LIBRARIES})

add_executable(convert_pcd_to_image tools/convert_pcd_to_image.cpp)
target_link_libraries(convert_pcd_to_image ${Boost_LIBRARIES} ${catkin_LIBRARIES} ${Eigen3_LIBRARIES} ${PCL_LIBRARIES})

add_executable(convert_pointcloud_to_image tools/convert_pointcloud_to_image.cpp)
target_link_libraries(convert_pointcloud_to_image ${Boost_LIBRARIES} ${catkin_LIBRARIES} ${Eigen3_LIBRARIES} ${PCL_LIBRARIES})

## Downloads

catkin_download(table_scene_lms400.pcd http://download.ros.org/data/pcl/table_scene_lms400.pcd
  DESTINATION ${CMAKE_CURRENT_SOURCE_DIR}/samples/data
  MD5 546b5b4822fb1de21b0cf83d41ad6683
)
add_custom_target(download ALL DEPENDS download_extra_data)

#############
## Testing ##
#############

if(CATKIN_ENABLE_TESTING)
  find_package(rostest REQUIRED)
  add_rostest_gtest(test_tf_message_filter_pcl tests/test_tf_message_filter_pcl.launch src/test/test_tf_message_filter_pcl.cpp)
  target_link_libraries(test_tf_message_filter_pcl ${catkin_LIBRARIES} ${GTEST_LIBRARIES})
  add_rostest(samples/pcl_ros/features/sample_normal_3d.launch ARGS gui:=false)
  add_rostest(samples/pcl_ros/filters/sample_statistical_outlier_removal.launch ARGS gui:=false)
  add_rostest(samples/pcl_ros/filters/sample_voxel_grid.launch ARGS gui:=false)
  add_rostest(samples/pcl_ros/segmentation/sample_extract_clusters.launch ARGS gui:=false)
  add_rostest(samples/pcl_ros/surface/sample_convex_hull.launch ARGS gui:=false)
endif(CATKIN_ENABLE_TESTING)


install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION})

install(
  TARGETS
    pcl_ros_tf
    pcl_ros_io
    pcl_ros_features
    pcl_ros_filters
    pcl_ros_surface
    pcl_ros_segmentation
    pcd_to_pointcloud
    pointcloud_to_pcd
    bag_to_pcd
    convert_pcd_to_image
    convert_pointcloud_to_image
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
)

install(DIRECTORY plugins samples
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION})

=== debian/changelog ===
ros-lunar-pcl-ros (1.5.4-0xenial) xenial; urgency=high

  * update to use non deprecated pluginlib macro
  * Fix config path of sample_voxel_grid.launch
  * remove hack now that upstream pcl has been rebuilt
  * Looser hzerror in test for extract_clusters to make it pass on Travis
  * Add sample & test for surface/convex_hull
  * Add sample & test for segmentation/extract_clusters.cpp
  * Add sample & test for io/concatenate_data.cpp
  * Add sample & test for features/normal_3d.cpp
  * Organize samples of pcl_ros/features
  * Add test arg to avoid duplicated testing
  * LazyNodelet for features/*
  * LazyNodelet for filters/ProjectInliers
  * Refactor io/PCDReader and io/PCDWriter as child of PCLNodelet
  * LazyNodelet for io/PointCloudConcatenateFieldsSynchronizer
  * LazyNodelet for io/PointCloudConcatenateDataSynchronizer
  * LazyNodelet for segmentation/SegmentDifferences
  * LazyNodelet for segmentation/SACSegmentationFromNormals
  * LazyNodelet for segmentation/SACSegmentation
  * LazyNodelet for segmentation/ExtractPolygonalPrismData
  * LazyNodelet for segmentation/EuclideanClusterExtraction
  * LazyNodelet for surface/MovingLeastSquares
  * LazyNodelet for surface/ConvexHull2D
  * Add missing COMPONENTS of PCL
  * Inherit NodeletLazy for pipeline with less cpu load
  * Set leaf_size 0.02
  * Install samples
  * Add sample and test for pcl/StatisticalOutlierRemoval
    Conflicts:
    pcl_ros/CMakeLists.txt
  * Add sample and test for pcl/VoxelGrid
    Conflicts:
    pcl_ros/CMakeLists.txt
  * no need to remove duplicates
  * spourious line change
  * remove now unnecessary build_depend on qtbase5
  * exclude PCL IO libraries exporting Qt flag
  * find only PCL components used instead of all PCL
  * Remove dependency on vtk/libproj-dev (#145 <https://github.com/ros-perception/perception_pcl/issues/145>)
    * Remove dependency on vtk/libproj-dev
    These dependencies were introduced in #124 <https://github.com/ros-perception/perception_pcl/issues/124> to temporarily fix
    missing / wrong dependencies in upstream vtk. This hack is no longer
    necessary, since fixed vtk packages have been uploaded to
    packages.ros.org (see #124 <https://github.com/ros-perception/perception_pcl/issues/124> and ros-infrastructure/reprepro-updater#32 <https://github.com/ros-infrastructure/reprepro-updater/issues/32>).
    * Remove vtk hack from CMakeLists.txt
  * Contributors: Kentaro Wada, Mikael Arguedas

 -- Paul Bovbel <paul@bovbel.com>  Fri, 30 Mar 2018 15:00:00 -0000

ros-lunar-pcl-ros (1.5.3-0xenial) xenial; urgency=high

  * Add dependency on qtbase5-dev for find_package(Qt5Widgets)
    See https://github.com/ros-perception/perception_pcl/pull/117#issuecomment-298158272 for detail.
  * Contributors: Kentaro Wada

 -- Paul Bovbel <paul@bovbel.com>  Tue, 02 May 2017 15:00:00 -0000

ros-lunar-pcl-ros (1.5.2-0xenial) xenial; urgency=high

  * Find Qt5Widgets to fix -lQt5::Widgets error
  * Contributors: Kentaro Wada

 -- Paul Bovbel <paul@bovbel.com>  Fri, 28 Apr 2017 15:00:00 -0000

ros-lunar-pcl-ros (1.5.1-0xenial) xenial; urgency=high

  * Add my name as a maintainer
  * Contributors: Kentaro Wada

 -- Paul Bovbel <paul@bovbel.com>  Tue, 25 Apr 2017 15:00:00 -0000

ros-lunar-pcl-ros (1.5.0-0xenial) xenial; urgency=high

  * Fix lib name duplication error in ubunt:zesty
  * Detect automatically the version of PCL in cmake
  * Install xml files declaring nodelets
  * Fix syntax of nodelet manifest file by splitting files for each library.
  * Contributors: Kentaro Wada

 -- Paul Bovbel <paul@bovbel.com>  Mon, 24 Apr 2017 15:00:00 -0000

ros-lunar-pcl-ros (1.4.0-0xenial) xenial; urgency=high

  * Fixup libproj-dev rosdep
  * Add build depend on libproj, since it's not provided by vtk right now
  * manually remove dependency on vtkproj from PCL_LIBRARIES
  * Remove python-vtk for kinetic-devel, see issue #44 <https://github.com/ros-perception/perception_pcl/issues/44>
  * Contributors: Jackie Kay, Paul Bovbel

 -- Paul Bovbel <paul@bovbel.com>  Thu, 21 Apr 2016 15:00:00 -0000

ros-lunar-pcl-ros (1.3.0-0xenial) xenial; urgency=high

  * cleanup broken library links
    All removed library names are included in ${PCL_LIBRARIES}.
    However, the plain library names broke catkin's overlay mechanism:
    Where ${PCL_LIBRARIES} could point to a local installation of the PCL,
    e.g. pcd_ros_segmentation might still link to the system-wide installed version
    of pcl_segmentation.
  * Fixed test for jade-devel. Progress on #92 <https://github.com/ros-perception/perception_pcl/issues/92>
  * commented out test_tf_message_filter_pcl
    Until ros/geometry#80 <https://github.com/ros/geometry/issues/80> has been merged the test will fail.
  * fixed indentation and author
  * Adds a test for tf message filters with pcl pointclouds
  * specialized HasHeader, TimeStamp, FrameId
    - HasHeader now returns false
    - TimeStamp and FrameId specialed for pcl::PointCloud<T> for any point type T
    These changes allow to use pcl::PointCloud with tf::MessageFilter
  * Sync pcl_nodelets.xml from hydro to indigo
    Fixes to pass catkin lint -W1
  * Fixes #87 <https://github.com/ros-perception/perception_pcl/issues/87> for Indigo
  * Fixes #85 <https://github.com/ros-perception/perception_pcl/issues/85> for Indigo
  * Fixes #77 <https://github.com/ros-perception/perception_pcl/issues/77> and #80 <https://github.com/ros-perception/perception_pcl/issues/80> for indigo
  * Added option to save pointclouds in binary and binary compressed format
  * Contributors: Brice Rebsamen, Lucid One, Mitchell Wills, v4hn

 -- Paul Bovbel <paul@bovbel.com>  Sun, 21 Jun 2015 15:00:00 -0000

ros-lunar-pcl-ros (1.2.6-0xenial) xenial; urgency=high



 -- Paul Bovbel <paul@bovbel.com>  Tue, 03 Feb 2015 15:00:00 -0000

ros-lunar-pcl-ros (1.2.5-0xenial) xenial; urgency=high



 -- Paul Bovbel <paul@bovbel.com>  Mon, 19 Jan 2015 15:00:00 -0000

ros-lunar-pcl-ros (1.2.4-0xenial) xenial; urgency=high





=== debian/control ===
Source: ros-lunar-pcl-ros
Section: misc
Priority: extra
Maintainer: Paul Bovbel <paul@bovbel.com>
Build-Depends: debhelper (>= 9.0.0), libeigen3-dev, libpcl-dev, ros-lunar-catkin, ros-lunar-cmake-modules, ros-lunar-dynamic-reconfigure, ros-lunar-genmsg, ros-lunar-message-filters, ros-lunar-nodelet, ros-lunar-nodelet-topic-tools, ros-lunar-pcl-conversions, ros-lunar-pcl-msgs, ros-lunar-pluginlib, ros-lunar-rosbag, ros-lunar-rosconsole, ros-lunar-roscpp, ros-lunar-roslib, ros-lunar-rostest, ros-lunar-sensor-msgs, ros-lunar-std-msgs, ros-lunar-tf, ros-lunar-tf2-eigen
Homepage: http://ros.org/wiki/perception_pcl
Standards-Version: 3.9.2

Package: ros-lunar-pcl-ros
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libeigen3-dev, libpcl-dev, ros-lunar-dynamic-reconfigure, ros-lunar-message-filters, ros-lunar-nodelet, ros-lunar-nodelet-topic-tools, ros-lunar-pcl-conversions, ros-lunar-pcl-msgs, ros-lunar-pluginlib, ros-lunar-rosbag, ros-lunar-roscpp, ros-lunar-sensor-msgs, ros-lunar-std-msgs, ros-lunar-tf, ros-lunar-tf2-eigen
Description: PCL (Point Cloud Library) ROS interface stack.
 PCL-ROS is the preferred bridge for 3D applications involving n-D Point Clouds and 3D geometry processing in ROS.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/lunar/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/lunar" \
		-DCMAKE_PREFIX_PATH="/opt/ros/lunar"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-lunar-pcl-ros//opt/ros/lunar/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_install
